diff -Naur openssl-1.0.0q.orig/crypto/ui/ui_util.c openssl-1.0.0q/crypto/ui/ui_util.c
--- openssl-1.0.0q.orig/crypto/ui/ui_util.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ui/ui_util.c	2017-04-25 16:23:40.686621900 +0200
@@ -53,7 +53,12 @@
  *
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "ui_locl.h"
 
 int UI_UTIL_read_pw_string(char *buf,int length,const char *prompt,int verify)
diff -Naur openssl-1.0.0q.orig/crypto/uid.c openssl-1.0.0q/crypto/uid.c
--- openssl-1.0.0q.orig/crypto/uid.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/uid.c	2017-04-25 16:23:40.686621900 +0200
@@ -53,9 +53,11 @@
  *
  */
 
-#include <openssl/crypto.h>
+#include <openssl/cryptlib.h>
 #include <openssl/opensslconf.h>
 
+#include <openssl/e_os.h>
+
 #if defined(__OpenBSD__) || (defined(__FreeBSD__) && __FreeBSD__ > 2)
 
 #include OPENSSL_UNISTD
@@ -72,10 +74,12 @@
 	return 0;
 	}
 
-#else
+#elif !defined(GROUP_USER_ID_IS_MEANINGLESS)
 
 #include OPENSSL_UNISTD
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 int OPENSSL_issetugid(void)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/x509/.gitignore openssl-1.0.0q/crypto/x509/.gitignore
--- openssl-1.0.0q.orig/crypto/x509/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/.gitignore	2017-04-25 16:23:40.687621748 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/x509/by_dir.c openssl-1.0.0q/crypto/x509/by_dir.c
--- openssl-1.0.0q.orig/crypto/x509/by_dir.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/by_dir.c	2017-04-25 16:23:40.688621595 +0200
@@ -56,19 +56,20 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
 #include <errno.h>
 
-#include "cryptlib.h"
-
 #ifndef NO_SYS_TYPES_H
 # include <sys/types.h>
 #endif
 #ifndef OPENSSL_NO_POSIX_IO
 # include <sys/stat.h>
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/x509.h>
 
@@ -465,7 +466,7 @@
 			{
 			ok=1;
 			ret->type=tmp->type;
-			memcpy(&ret->data,&tmp->data,sizeof(ret->data));
+			op_memcpy(&ret->data,&tmp->data,sizeof(ret->data));
 			/* If we were going to up the reference count,
 			 * we would need to do it on a perl 'type'
 			 * basis */
diff -Naur openssl-1.0.0q.orig/crypto/x509/by_file.c openssl-1.0.0q/crypto/x509/by_file.c
--- openssl-1.0.0q.orig/crypto/x509/by_file.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/by_file.c	2017-04-25 16:23:40.689621443 +0200
@@ -56,11 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/buffer.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509/opera_x509_set.cpp openssl-1.0.0q/crypto/x509/opera_x509_set.cpp
--- openssl-1.0.0q.orig/crypto/x509/opera_x509_set.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/opera_x509_set.cpp	2017-04-25 16:23:40.692621266 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "x509_set.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/x509/opera_x509spki.cpp openssl-1.0.0q/crypto/x509/opera_x509spki.cpp
--- openssl-1.0.0q.orig/crypto/x509/opera_x509spki.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/opera_x509spki.cpp	2017-04-25 16:23:40.695621088 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+extern "C" {
+#include "x509spki.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509.h openssl-1.0.0q/crypto/x509/x509.h
--- openssl-1.0.0q.orig/crypto/x509/x509.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509.h	2017-04-25 16:23:40.697621342 +0200
@@ -303,7 +303,7 @@
 	struct ASIdentifiers_st *rfc3779_asid;
 #endif
 #ifndef OPENSSL_NO_SHA
-	unsigned char sha1_hash[SHA_DIGEST_LENGTH];
+	unsigned char sha1_hash[SHA_DIGEST_LENGTH]; /* ARRAY OK 2009-10-02 alexeik */
 #endif
 	X509_CERT_AUX *aux;
 	} /* X509 */;
@@ -316,8 +316,8 @@
 typedef struct x509_trust_st {
 	int trust;
 	int flags;
-	int (*check_trust)(struct x509_trust_st *, X509 *, int);
-	char *name;
+	int (*check_trust)(const struct x509_trust_st *, X509 *, int);
+	const char *name;
 	int arg1;
 	void *arg2;
 } X509_TRUST;
@@ -551,7 +551,7 @@
 /* Unused (and iv length is wrong)
 typedef struct CBCParameter_st
 	{
-	unsigned char iv[8];
+	unsigned char iv[8]; // ARRAY OK 2007-11-07 yngve
 	} CBC_PARAM;
 */
 
@@ -1189,7 +1189,7 @@
 
 int X509_check_trust(X509 *x, int id, int flags);
 int X509_TRUST_get_count(void);
-X509_TRUST * X509_TRUST_get0(int idx);
+const X509_TRUST * X509_TRUST_get0(int idx);
 int X509_TRUST_get_by_id(int id);
 int X509_TRUST_add(int id, int flags, int (*ck)(X509_TRUST *, X509 *, int),
 					char *name, int arg1, void *arg2);
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_att.c openssl-1.0.0q/crypto/x509/x509_att.c
--- openssl-1.0.0q.orig/crypto/x509/x509_att.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_att.c	2017-04-25 16:23:40.698621749 +0200
@@ -56,19 +56,23 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/stack.h>
-#include "cryptlib.h"
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
+#ifndef OPERA_SMALL_VERSION
 int X509at_get_attr_count(const STACK_OF(X509_ATTRIBUTE) *x)
 {
 	return sk_X509_ATTRIBUTE_num(x);
 }
+#endif
 
 int X509at_get_attr_by_NID(const STACK_OF(X509_ATTRIBUTE) *x, int nid,
 			  int lastpos)
@@ -108,6 +112,7 @@
 		return sk_X509_ATTRIBUTE_value(x,loc);
 }
 
+#ifndef OPERA_SMALL_VERSION
 X509_ATTRIBUTE *X509at_delete_attr(STACK_OF(X509_ATTRIBUTE) *x, int loc)
 {
 	X509_ATTRIBUTE *ret;
@@ -117,6 +122,7 @@
 	ret=sk_X509_ATTRIBUTE_delete(x,loc);
 	return(ret);
 }
+#endif /* OPERA_SMALL_VERSION */
 
 STACK_OF(X509_ATTRIBUTE) *X509at_add1_attr(STACK_OF(X509_ATTRIBUTE) **x,
 					 X509_ATTRIBUTE *attr)
@@ -285,11 +291,11 @@
 int X509_ATTRIBUTE_set1_data(X509_ATTRIBUTE *attr, int attrtype, const void *data, int len)
 {
 	ASN1_TYPE *ttmp;
-	ASN1_STRING *stmp = NULL;
+	ASN1_STRING *stmp = NULL, *stmp_alloc=NULL;
 	int atype = 0;
 	if (!attr) return 0;
 	if(attrtype & MBSTRING_FLAG) {
-		stmp = ASN1_STRING_set_by_NID(NULL, data, len, attrtype,
+		stmp = ASN1_STRING_set_by_NID(NULL, (const unsigned char *) data, len, attrtype,
 						OBJ_obj2nid(attr->object));
 		if(!stmp) {
 			X509err(X509_F_X509_ATTRIBUTE_SET1_DATA, ERR_R_ASN1_LIB);
@@ -297,7 +303,7 @@
 		}
 		atype = stmp->type;
 	} else if (len != -1){
-		if(!(stmp = ASN1_STRING_type_new(attrtype))) goto err;
+		if(!(stmp_alloc=stmp = ASN1_STRING_type_new(attrtype))) goto err;
 		if(!ASN1_STRING_set(stmp, data, len)) goto err;
 		atype = attrtype;
 	}
@@ -320,6 +326,8 @@
 	if(!sk_ASN1_TYPE_push(attr->value.set, ttmp)) goto err;
 	return 1;
 	err:
+	if(stmp_alloc)
+		ASN1_STRING_free(stmp_alloc);
 	X509err(X509_F_X509_ATTRIBUTE_SET1_DATA, ERR_R_MALLOC_FAILURE);
 	return 0;
 }
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_cmp.c openssl-1.0.0q/crypto/x509/x509_cmp.c
--- openssl-1.0.0q.orig/crypto/x509/x509_cmp.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_cmp.c	2017-04-25 16:23:40.700621724 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
@@ -81,12 +83,12 @@
 	{
 	unsigned long ret=0;
 	EVP_MD_CTX ctx;
-	unsigned char md[16];
+	unsigned char md[16]; /* ARRAY OK 2007-11-07 yngve UNUSED */
 	char *f;
 
 	EVP_MD_CTX_init(&ctx);
 	f=X509_NAME_oneline(a->cert_info->issuer,NULL,0);
-	ret=strlen(f);
+	ret=op_strlen(f);
 	EVP_DigestInit_ex(&ctx, EVP_md5(), NULL);
 	EVP_DigestUpdate(&ctx,(unsigned char *)f,ret);
 	OPENSSL_free(f);
@@ -111,10 +113,12 @@
 	return(X509_NAME_cmp(a->cert_info->subject,b->cert_info->subject));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_CRL_cmp(const X509_CRL *a, const X509_CRL *b)
 	{
 	return(X509_NAME_cmp(a->crl->issuer,b->crl->issuer));
 	}
+#endif
 
 #ifndef OPENSSL_NO_SHA
 int X509_CRL_match(const X509_CRL *a, const X509_CRL *b)
@@ -128,10 +132,12 @@
 	return(a->cert_info->issuer);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 unsigned long X509_issuer_name_hash(X509 *x)
 	{
 	return(X509_NAME_hash(x->cert_info->issuer));
 	}
+#endif
 
 #ifndef OPENSSL_NO_MD5
 unsigned long X509_issuer_name_hash_old(X509 *x)
@@ -150,10 +156,12 @@
 	return(a->cert_info->serialNumber);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 unsigned long X509_subject_name_hash(X509 *x)
 	{
 	return(X509_NAME_hash(x->cert_info->subject));
 	}
+#endif
 
 #ifndef OPENSSL_NO_MD5
 unsigned long X509_subject_name_hash_old(X509 *x)
@@ -178,7 +186,7 @@
 	X509_check_purpose((X509 *)a, -1, 0);
 	X509_check_purpose((X509 *)b, -1, 0);
 
-	return memcmp(a->sha1_hash, b->sha1_hash, SHA_DIGEST_LENGTH);
+	return op_memcmp(a->sha1_hash, b->sha1_hash, SHA_DIGEST_LENGTH);
 }
 #endif
 
@@ -298,6 +306,7 @@
 	return x->cert_info->key->public_key;
 	}
 
+#if defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int X509_check_private_key(X509 *x, EVP_PKEY *k)
 	{
 	EVP_PKEY *xk;
@@ -329,3 +338,4 @@
 		return 1;
 	return 0;
 	}
+#endif // defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_d2.c openssl-1.0.0q/crypto/x509/x509_d2.c
--- openssl-1.0.0q.orig/crypto/x509/x509_d2.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_d2.c	2017-04-25 16:23:40.701621572 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/crypto.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_def.c openssl-1.0.0q/crypto/x509/x509_def.c
--- openssl-1.0.0q.orig/crypto/x509/x509_def.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_def.c	2017-04-25 16:23:40.701621572 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/crypto.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_err.c openssl-1.0.0q/crypto/x509/x509_err.c
--- openssl-1.0.0q.orig/crypto/x509/x509_err.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_err.c	2017-04-25 16:23:40.702621140 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/x509.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_ext.c openssl-1.0.0q/crypto/x509/x509_ext.c
--- openssl-1.0.0q.orig/crypto/x509/x509_ext.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_ext.c	2017-04-25 16:23:40.703621826 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/stack.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
@@ -122,6 +124,7 @@
 	return(X509v3_get_ext_by_NID(x->cert_info->extensions,nid,lastpos));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_get_ext_by_OBJ(X509 *x, ASN1_OBJECT *obj, int lastpos)
 	{
 	return(X509v3_get_ext_by_OBJ(x->cert_info->extensions,obj,lastpos));
@@ -131,12 +134,14 @@
 	{
 	return(X509v3_get_ext_by_critical(x->cert_info->extensions,crit,lastpos));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 X509_EXTENSION *X509_get_ext(X509 *x, int loc)
 	{
 	return(X509v3_get_ext(x->cert_info->extensions,loc));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 X509_EXTENSION *X509_delete_ext(X509 *x, int loc)
 	{
 	return(X509v3_delete_ext(x->cert_info->extensions,loc));
@@ -146,12 +151,15 @@
 	{
 	return(X509v3_add_ext(&(x->cert_info->extensions),ex,loc) != NULL);
 	}
+#endif /* OPERA_SMALL_VERSION */
+
 
 void *X509_get_ext_d2i(X509 *x, int nid, int *crit, int *idx)
 {
 	return X509V3_get_d2i(x->cert_info->extensions, nid, crit, idx);
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509_add1_ext_i2d(X509 *x, int nid, void *value, int crit,
 							unsigned long flags)
 {
@@ -194,17 +202,20 @@
 	{
 	return(X509v3_add_ext(&(x->extensions),ex,loc) != NULL);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 void *X509_REVOKED_get_ext_d2i(X509_REVOKED *x, int nid, int *crit, int *idx)
 {
 	return X509V3_get_d2i(x->extensions, nid, crit, idx);
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509_REVOKED_add1_ext_i2d(X509_REVOKED *x, int nid, void *value, int crit,
 							unsigned long flags)
 {
 	return X509V3_add1_i2d(&x->extensions, nid, value, crit, flags);
 }
+#endif // !OPERA_SMALL_VERSION
 
 IMPLEMENT_STACK_OF(X509_EXTENSION)
 IMPLEMENT_ASN1_SET_OF(X509_EXTENSION)
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_lu.c openssl-1.0.0q/crypto/x509/x509_lu.c
--- openssl-1.0.0q.orig/crypto/x509/x509_lu.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_lu.c	2017-04-25 16:23:40.704621394 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
@@ -91,6 +93,7 @@
 	OPENSSL_free(ctx);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_LOOKUP_init(X509_LOOKUP *ctx)
 	{
 	if (ctx->method == NULL) return 0;
@@ -99,6 +102,7 @@
 	else
 		return 1;
 	}
+#endif
 
 int X509_LOOKUP_shutdown(X509_LOOKUP *ctx)
 	{
@@ -109,6 +113,7 @@
 		return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_LOOKUP_ctrl(X509_LOOKUP *ctx, int cmd, const char *argc, long argl,
 	     char **ret)
 	{
@@ -118,6 +123,7 @@
 	else
 		return 1;
 	}
+#endif
 
 int X509_LOOKUP_by_subject(X509_LOOKUP *ctx, int type, X509_NAME *name,
 	     X509_OBJECT *ret)
@@ -128,6 +134,7 @@
 	return ctx->method->get_by_subject(ctx,type,name,ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_LOOKUP_by_issuer_serial(X509_LOOKUP *ctx, int type, X509_NAME *name,
 	     ASN1_INTEGER *serial, X509_OBJECT *ret)
 	{
@@ -152,6 +159,7 @@
 		return X509_LU_FAIL;
 	return ctx->method->get_by_alias(ctx,type,str,len,ret);
 	}
+#endif
 
   
 static int x509_object_cmp(const X509_OBJECT * const *a, const X509_OBJECT * const *b)
@@ -165,9 +173,11 @@
  	case X509_LU_X509:
  		ret=X509_subject_name_cmp((*a)->data.x509,(*b)->data.x509);
  		break;
+#ifndef OPERA_SMALL_VERSION
  	case X509_LU_CRL:
  		ret=X509_CRL_cmp((*a)->data.crl,(*b)->data.crl);
  		break;
+#endif
 	default:
 		/* abort(); */
 		return 0;
@@ -186,9 +196,13 @@
 	ret->get_cert_methods=sk_X509_LOOKUP_new_null();
 	ret->verify=0;
 	ret->verify_cb=0;
+	ret->param = X509_VERIFY_PARAM_new();
 
-	if ((ret->param = X509_VERIFY_PARAM_new()) == NULL)
+	if (ret->objs == NULL || ret->get_cert_methods == NULL || ret->param == NULL)
+	{
+		X509_STORE_free(ret);
 		return NULL;
+	}
 
 	ret->get_issuer = 0;
 	ret->check_issued = 0;
@@ -202,8 +216,7 @@
 
 	if (!CRYPTO_new_ex_data(CRYPTO_EX_INDEX_X509_STORE, ret, &ret->ex_data))
 		{
-		sk_X509_OBJECT_free(ret->objs);
-		OPENSSL_free(ret);
+		X509_STORE_free(ret);
 		return NULL;
 		}
 
@@ -217,10 +230,12 @@
 		{
 		X509_free(a->data.x509);
 		}
+#ifndef OPERA_SMALL_VERSION
 	else if (a->type == X509_LU_CRL)
 		{
 		X509_CRL_free(a->data.crl);
 		}
+#endif
 	else
 		{
 		/* abort(); */
@@ -364,6 +379,7 @@
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_STORE_add_crl(X509_STORE *ctx, X509_CRL *x)
 	{
 	X509_OBJECT *obj;
@@ -396,6 +412,7 @@
 
 	return ret;
 	}
+#endif
 
 void X509_OBJECT_up_ref_count(X509_OBJECT *a)
 	{
@@ -404,9 +421,11 @@
 	case X509_LU_X509:
 		CRYPTO_add(&a->data.x509->references,1,CRYPTO_LOCK_X509);
 		break;
+#ifndef OPERA_SMALL_VERSION
 	case X509_LU_CRL:
 		CRYPTO_add(&a->data.crl->references,1,CRYPTO_LOCK_X509_CRL);
 		break;
+#endif
 		}
 	}
 
@@ -417,9 +436,11 @@
 	case X509_LU_X509:
 		X509_free(a->data.x509);
 		break;
+#ifndef OPERA_SMALL_VERSION
 	case X509_LU_CRL:
 		X509_CRL_free(a->data.crl);
 		break;
+#endif
 		}
 	}
 
@@ -429,8 +450,10 @@
 	X509_OBJECT stmp;
 	X509 x509_s;
 	X509_CINF cinf_s;
+#ifndef OPERA_SMALL_VERSION
 	X509_CRL crl_s;
 	X509_CRL_INFO crl_info_s;
+#endif
 	int idx;
 
 	stmp.type=type;
@@ -441,11 +464,13 @@
 		x509_s.cert_info= &cinf_s;
 		cinf_s.subject=name;
 		break;
+#ifndef OPERA_SMALL_VERSION
 	case X509_LU_CRL:
 		stmp.data.crl= &crl_s;
 		crl_s.crl= &crl_info_s;
 		crl_info_s.issuer=name;
 		break;
+#endif
 	default:
 		/* abort(); */
 		return -1;
@@ -680,6 +705,7 @@
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_STORE_set_flags(X509_STORE *ctx, unsigned long flags)
 	{
 	return X509_VERIFY_PARAM_set_flags(ctx->param, flags);
@@ -711,6 +737,7 @@
 	{
 	ctx->verify_cb = verify_cb;
 	}
+#endif
 
 IMPLEMENT_STACK_OF(X509_LOOKUP)
 IMPLEMENT_STACK_OF(X509_OBJECT)
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_obj.c openssl-1.0.0q/crypto/x509/x509_obj.c
--- openssl-1.0.0q.orig/crypto/x509/x509_obj.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_obj.c	2017-04-25 16:23:40.705620963 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
@@ -72,11 +74,11 @@
 	char *p;
 	unsigned char *q;
 	BUF_MEM *b=NULL;
-	static const char hex[17]="0123456789ABCDEF";
-	int gs_doit[4];
-	char tmp_buf[80];
+	static const char hex[17]="0123456789ABCDEF"; /* ARRAY OK 2011-09-16 alexeik */
+	int gs_doit[4];			/* ARRAY OK 2009-05-25 yngve */
+	char tmp_buf[80];		/* ARRAY OK 2009-05-25 yngve */
 #ifdef CHARSET_EBCDIC
-	char ebcdic_buf[1024];
+	char ebcdic_buf[1024];	/* ARRAY OK UNUSED 2009-05-25 yngve EBCDIC only*/
 #endif
 
 	if (buf == NULL)
@@ -93,7 +95,7 @@
 		buf=b->data;
 		OPENSSL_free(b);
 		}
-	    strncpy(buf,"NO X509_NAME",len);
+	    op_strncpy(buf,"NO X509_NAME",len);
 	    buf[len-1]='\0';
 	    return buf;
 	    }
@@ -109,7 +111,7 @@
 			i2t_ASN1_OBJECT(tmp_buf,sizeof(tmp_buf),ne->object);
 			s=tmp_buf;
 			}
-		l1=strlen(s);
+		l1=op_strlen(s);
 
 		type=ne->value->type;
 		num=ne->value->length;
@@ -171,7 +173,7 @@
 		else
 			p= &(buf[lold]);
 		*(p++)='/';
-		memcpy(p,s,(unsigned int)l1); p+=l1;
+		op_memcpy(p,s,(unsigned int)l1); p+=l1;
 		*(p++)='=';
 
 #ifndef CHARSET_EBCDIC /* q was assigned above already. */
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_r2x.c openssl-1.0.0q/crypto/x509/x509_r2x.c
--- openssl-1.0.0q.orig/crypto/x509/x509_r2x.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_r2x.c	2017-04-25 16:23:40.706620810 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bn.h>
 #include <openssl/evp.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_req.c openssl-1.0.0q/crypto/x509/x509_req.c
--- openssl-1.0.0q.orig/crypto/x509/x509_req.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_req.c	2017-04-25 16:23:40.707620658 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/bn.h>
 #include <openssl/evp.h>
@@ -67,6 +69,7 @@
 #include <openssl/buffer.h>
 #include <openssl/pem.h>
 
+#ifndef OPERA_SMALL_VERSION
 X509_REQ *X509_to_X509_REQ(X509 *x, EVP_PKEY *pkey, const EVP_MD *md)
 	{
 	X509_REQ *ret;
@@ -159,9 +162,14 @@
  * used and there may be more: so the list is configurable.
  */
 
-static int ext_nid_list[] = { NID_ext_req, NID_ms_ext_req, NID_undef};
+static const int ext_nid_list[] = { NID_ext_req, NID_ms_ext_req, NID_undef};
 
+#ifdef _NO_GLOBALS_
+extern int* *g_ext_nids_addr();
+#define ext_nids (*g_ext_nids_addr())
+#else
 static int *ext_nids = ext_nid_list;
+#endif
 
 int X509_REQ_extension_nid(int req_nid)
 {
@@ -314,3 +322,4 @@
 				type, bytes, len)) return 1;
 	return 0;
 }
+#endif /* OPERA_SMALL_VERSION */
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_set.c openssl-1.0.0q/crypto/x509/x509_set.c
--- openssl-1.0.0q.orig/crypto/x509/x509_set.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_set.c	2017-04-25 16:23:40.708620506 +0200
@@ -56,13 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
 
+#ifndef OPERA_SMALL_VERSION
 int X509_set_version(X509 *x, long version)
 	{
 	if (x == NULL) return(0);
@@ -145,6 +148,7 @@
 	if ((x == NULL) || (x->cert_info == NULL)) return(0);
 	return(X509_PUBKEY_set(&(x->cert_info->key),pkey));
 	}
+#endif
 
 
 
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_trs.c openssl-1.0.0q/crypto/x509/x509_trs.c
--- openssl-1.0.0q.orig/crypto/x509/x509_trs.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_trs.c	2017-04-25 16:23:40.709620633 +0200
@@ -56,50 +56,81 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 static int tr_cmp(const X509_TRUST * const *a,
 		const X509_TRUST * const *b);
 static void trtable_free(X509_TRUST *p);
+#endif
 
-static int trust_1oidany(X509_TRUST *trust, X509 *x, int flags);
-static int trust_1oid(X509_TRUST *trust, X509 *x, int flags);
-static int trust_compat(X509_TRUST *trust, X509 *x, int flags);
+static int trust_1oidany(const X509_TRUST *trust, X509 *x, int flags);
+static int trust_1oid(const X509_TRUST *trust, X509 *x, int flags);
+static int trust_compat(const X509_TRUST *trust, X509 *x, int flags);
 
 static int obj_trust(int id, X509 *x, int flags);
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
+#ifdef _NO_GLOBALS_
+#define default_trust obj_trust
+#else
 static int (*default_trust)(int id, X509 *x, int flags) = obj_trust;
+#endif
+#else
+#define default_trust obj_trust
+#endif
 
 /* WARNING: the following table should be kept in order of trust
  * and without any gaps so we can just subtract the minimum trust
  * value to get an index into the table
  */
 
-static X509_TRUST trstandard[] = {
-{X509_TRUST_COMPAT, 0, trust_compat, "compatible", 0, NULL},
-{X509_TRUST_SSL_CLIENT, 0, trust_1oidany, "SSL Client", NID_client_auth, NULL},
-{X509_TRUST_SSL_SERVER, 0, trust_1oidany, "SSL Server", NID_server_auth, NULL},
-{X509_TRUST_EMAIL, 0, trust_1oidany, "S/MIME email", NID_email_protect, NULL},
-{X509_TRUST_OBJECT_SIGN, 0, trust_1oidany, "Object Signer", NID_code_sign, NULL},
-{X509_TRUST_OCSP_SIGN, 0, trust_1oid, "OCSP responder", NID_OCSP_sign, NULL},
-{X509_TRUST_OCSP_REQUEST, 0, trust_1oid, "OCSP request", NID_ad_OCSP, NULL},
-{X509_TRUST_TSA, 0, trust_1oidany, "TSA server", NID_time_stamp, NULL}
-};
+#define X509_TRUST_ENTRY(_trust, flg, ch_trst, nam, a1, a2) \
+	CONST_ENTRY_START(trust, _trust)\
+	CONST_ENTRY_SINGLE(flags, flg)\
+	CONST_ENTRY_SINGLE(check_trust, ch_trst)\
+	CONST_ENTRY_SINGLE(name, nam)\
+	CONST_ENTRY_SINGLE(arg1, a1)\
+	CONST_ENTRY_SINGLE(arg2, a2)\
+CONST_ENTRY_END
+
+OPENSSL_PREFIX_CONST_ARRAY(static, X509_TRUST, trstandard, libopeay)
+X509_TRUST_ENTRY(X509_TRUST_COMPAT, 0, trust_compat, "compatible", 0, NULL)
+X509_TRUST_ENTRY(X509_TRUST_SSL_CLIENT, 0, trust_1oidany, "SSL Client", NID_client_auth, NULL)
+X509_TRUST_ENTRY(X509_TRUST_SSL_SERVER, 0, trust_1oidany, "SSL Server", NID_server_auth, NULL)
+X509_TRUST_ENTRY(X509_TRUST_EMAIL, 0, trust_1oidany, "S/MIME email", NID_email_protect, NULL)
+X509_TRUST_ENTRY(X509_TRUST_OBJECT_SIGN, 0, trust_1oidany, "Object Signer", NID_code_sign, NULL)
+X509_TRUST_ENTRY(X509_TRUST_OCSP_SIGN, 0, trust_1oid, "OCSP responder", NID_OCSP_sign, NULL)
+X509_TRUST_ENTRY(X509_TRUST_OCSP_REQUEST, 0, trust_1oid, "OCSP request", NID_ad_OCSP, NULL)
+X509_TRUST_ENTRY(X509_TRUST_TSA, 0, trust_1oidany,"TSA server",NID_time_stamp, NULL)
+CONST_END(trstandard)
 
-#define X509_TRUST_COUNT	(sizeof(trstandard)/sizeof(X509_TRUST))
+#define X509_TRUST_COUNT	OPENSSL_CONST_ARRAY_SIZE(trstandard)
 
 IMPLEMENT_STACK_OF(X509_TRUST)
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
+#ifdef _NO_GLOBALS_
+OPENSSL_IMPLEMENT_GLOBAL(STACK_OF(X509_TRUST) *, trtable);
+#define trtable OPENSSL_GLOBAL_REF(trtable)
+#else
 static STACK_OF(X509_TRUST) *trtable = NULL;
+#endif // _NO_GLOBALS_
+#endif
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 static int tr_cmp(const X509_TRUST * const *a,
 		const X509_TRUST * const *b)
 {
 	return (*a)->trust - (*b)->trust;
 }
 
+#ifndef _NO_GLOBALS_
 int (*X509_TRUST_set_default(int (*trust)(int , X509 *, int)))(int, X509 *, int)
 {
 	int (*oldtrust)(int , X509 *, int);
@@ -107,11 +138,12 @@
 	default_trust = trust;
 	return oldtrust;
 }
-
+#endif
+#endif
 
 int X509_check_trust(X509 *x, int id, int flags)
 {
-	X509_TRUST *pt;
+	const X509_TRUST *pt;
 	int idx;
 	if(id == -1) return 1;
 	idx = X509_TRUST_get_by_id(id);
@@ -120,32 +152,47 @@
 	return pt->check_trust(pt, x, flags);
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509_TRUST_get_count(void)
 {
 	if(!trtable) return X509_TRUST_COUNT;
 	return sk_X509_TRUST_num(trtable) + X509_TRUST_COUNT;
 }
+#endif
 
-X509_TRUST * X509_TRUST_get0(int idx)
+const X509_TRUST* X509_TRUST_get0(int idx)
 {
 	if(idx < 0) return NULL;
-	if(idx < (int)X509_TRUST_COUNT) return trstandard + idx;
+	if(idx < (int)X509_TRUST_COUNT) return OPENSSL_GLOBAL_ARRAY_NAME(trstandard) + idx;
+#ifndef OPERA_SMALL_VERSION
 	return sk_X509_TRUST_value(trtable, idx - X509_TRUST_COUNT);
+#else
+	return NULL;
+#endif
 }
 
 int X509_TRUST_get_by_id(int id)
 {
+#ifndef OPERA_SMALL_VERSION
 	X509_TRUST tmp;
 	int idx;
+#endif
+
 	if((id >= X509_TRUST_MIN) && (id <= X509_TRUST_MAX))
 				 return id - X509_TRUST_MIN;
+
+#ifdef OPERA_SMALL_VERSION
+	return -1;
+#else
 	tmp.trust = id;
 	if(!trtable) return -1;
 	idx = sk_X509_TRUST_find(trtable, &tmp);
 	if(idx == -1) return -1;
 	return idx + X509_TRUST_COUNT;
+#endif
 }
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int X509_TRUST_set(int *t, int trust)
 {
 	if(X509_TRUST_get_by_id(trust) == -1) {
@@ -169,15 +216,15 @@
 	idx = X509_TRUST_get_by_id(id);
 	/* Need a new entry */
 	if(idx == -1) {
-		if(!(trtmp = OPENSSL_malloc(sizeof(X509_TRUST)))) {
+		if(!(trtmp = (X509_TRUST*)OPENSSL_malloc(sizeof(X509_TRUST)))) {
 			X509err(X509_F_X509_TRUST_ADD,ERR_R_MALLOC_FAILURE);
 			return 0;
 		}
 		trtmp->flags = X509_TRUST_DYNAMIC;
-	} else trtmp = X509_TRUST_get0(idx);
+	} else trtmp = (X509_TRUST*)X509_TRUST_get0(idx);
 
 	/* OPENSSL_free existing name if dynamic */
-	if(trtmp->flags & X509_TRUST_DYNAMIC_NAME) OPENSSL_free(trtmp->name);
+	if(trtmp->flags & X509_TRUST_DYNAMIC_NAME) OPENSSL_free((void*)trtmp->name);
 	/* dup supplied name */
 	if(!(trtmp->name = BUF_strdup(name))) {
 		X509err(X509_F_X509_TRUST_ADD,ERR_R_MALLOC_FAILURE);
@@ -189,7 +236,7 @@
 	trtmp->flags |= flags;
 
 	trtmp->trust = id;
-	trtmp->check_trust = ck;
+	trtmp->check_trust = (int (*)(const x509_trust_st*, X509*, int)) ck;
 	trtmp->arg1 = arg1;
 	trtmp->arg2 = arg2;
 
@@ -213,7 +260,7 @@
 	if (p->flags & X509_TRUST_DYNAMIC) 
 		{
 		if (p->flags & X509_TRUST_DYNAMIC_NAME)
-			OPENSSL_free(p->name);
+			OPENSSL_free((void*)p->name);
 		OPENSSL_free(p);
 		}
 	}
@@ -221,7 +268,7 @@
 void X509_TRUST_cleanup(void)
 {
 	unsigned int i;
-	for(i = 0; i < X509_TRUST_COUNT; i++) trtable_free(trstandard + i);
+	for(i = 0; i < X509_TRUST_COUNT; i++) trtable_free((X509_TRUST*)(OPENSSL_GLOBAL_ARRAY_NAME(trstandard) + i));
 	sk_X509_TRUST_pop_free(trtable, trtable_free);
 	trtable = NULL;
 }
@@ -233,15 +280,16 @@
 
 char *X509_TRUST_get0_name(X509_TRUST *xp)
 {
-	return xp->name;
+	return (char*)xp->name;
 }
 
 int X509_TRUST_get_trust(X509_TRUST *xp)
 {
 	return xp->trust;
 }
+#endif
 
-static int trust_1oidany(X509_TRUST *trust, X509 *x, int flags)
+static int trust_1oidany(const X509_TRUST *trust, X509 *x, int flags)
 {
 	if(x->aux && (x->aux->trust || x->aux->reject))
 		return obj_trust(trust->arg1, x, flags);
@@ -251,13 +299,13 @@
 	return trust_compat(trust, x, flags);
 }
 
-static int trust_1oid(X509_TRUST *trust, X509 *x, int flags)
+static int trust_1oid(const X509_TRUST *trust, X509 *x, int flags)
 {
 	if(x->aux) return obj_trust(trust->arg1, x, flags);
 	return X509_TRUST_UNTRUSTED;
 }
 
-static int trust_compat(X509_TRUST *trust, X509 *x, int flags)
+static int trust_compat(const X509_TRUST *trust, X509 *x, int flags)
 {
 	X509_check_purpose(x, -1, 0);
 	if(x->ex_flags & EXFLAG_SS) return X509_TRUST_TRUSTED;
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_txt.c openssl-1.0.0q/crypto/x509/x509_txt.c
--- openssl-1.0.0q.orig/crypto/x509/x509_txt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_txt.c	2017-04-25 16:23:40.709620633 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "cryptlib.h"
 #include <openssl/lhash.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_v3.c openssl-1.0.0q/crypto/x509/x509_v3.c
--- openssl-1.0.0q.orig/crypto/x509/x509_v3.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_v3.c	2017-04-25 16:23:40.710621039 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/stack.h>
-#include "cryptlib.h"
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
@@ -180,6 +182,7 @@
 	return(NULL);
 	}
 
+#if !defined OPERA_SMALL_VERSION || !defined OPENSSL_NO_OCSP
 X509_EXTENSION *X509_EXTENSION_create_by_NID(X509_EXTENSION **ex, int nid,
 	     int crit, ASN1_OCTET_STRING *data)
 	{
@@ -253,6 +256,7 @@
 	if (!i) return(0);
 	return(1);
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 ASN1_OBJECT *X509_EXTENSION_get_object(X509_EXTENSION *ex)
 	{
